{
  "openapi" : "3.0.1",
  "info" : {
    "title" : "Docmosis Cloud - API",
    "description" : "# Introduction\n\n## Overview\n\nDocmosis Cloud Service provides an easy way to generate dynamic documents from virtually any application.\n\nThis Cloud API documentation contains details of all available endpoints and allows live requests to the API to be executed.\n\n### Related Reading\n\nRead more about _[features of the Docmosis Cloud](https://www.docmosis.com/products/cloud/)_. \n\nDownload the full _[Cloud Documentation](https://resources.docmosis.com/documentation/cloud/latest)_. \n\n## Key Concepts\n\n### HTTP Methods\n\nAll requests to the Cloud API should be made using the HTTPS POST method.\n\n### Content-Type\n\nThe content-type varies depending on the service being used.  All services accept multi-part/form-data.  The Render service is the most versatile and can also accept application/json, application/xml and application/x-www-form-urlencoded.\n\n### Parameters\n\nRequests must include the API access key in either the header or body parameters.  All other parameters should be body parameters.  The API does not use query string parameters.\n\n### Character Encoding\n\nAll data passed to the Cloud API should be UTF-8 encoded. If data is passed containing special characters, it must be UTF-8 encoded, otherwise unexpected characters may appear in resulting documents.\n\n### Fonts in Templates\n\nTemplates should only use fonts that are available on the Cloud Service. If fonts are used which are not installed, unexpected font substitutions may occur in PDF documents or inaccurate page references when using indexes or tables of content.\n\nPlease see _[DWS4 Font List](https://resources.docmosis.com/content/faq/is-there-a-list-of-fonts-for-docmosis-cloud-dws4)_ for a list of available fonts.\n\n### Production vs Development Mode\n\nSome API endpoints provide the option to operate in a forgiving manner (development mode) or in a very strict manner (production mode).\n\nThe intention is that, in development mode, requests to the endpoints will succeed even if errors are detected, helping users to locate the error and make the necessary adjustments.\n\nIn production mode, requests will fail with diagnostic information returned in the response to the calling application.\n\n\n# The Service API\n\n## Endpoint URLs and Processing Locations\n\nWhen calling the API the Base URL determines the location that will process the request.\n\nThe available locations are:\n\n| **Location** | **Base URL** |\n| --- | --- |\n| United States | https://<area>us1.dws4.docmosis.com/api/ |\n| Europe | https://<area>eu1.dws4.docmosis.com/api/ |\n| Australia | https://<area>au1.dws4.docmosis.com/api/ |\n\nEach processing location is independent of the others and each Cloud Account has access to all locations.\n\nEach location has its own templates and all processing is confined to that location to support data-sovereignty and privacy requirements as well as optimizing performance.\n\nFor example, to upload a template to the Cloud Service in the US and then render it, these two API URLs would be used:\n\nhttps://**us1**.dws4.docmosis.com/api/**uploadTemplate**\n\nhttps://**us1**.dws4.docmosis.com/api/**render**\n\nSince each Docmosis location is independent of the others the templates must be stored in the same location as the location being used for rendering.\n\n## Response Codes and Messages\n\nFor every request made to the Cloud API, the first action should be to check the response status code to determine whether the call succeeded or failed. The choice can then be made whether to check for further information in the response body.\n\nThe API returns status codes as follows:\n\n| **Status Code** | **Definition** |\n| --- | --- |\n| 200 | Successful operation |\n| 400 | The request is not valid or indicates a not-ready status. |\n| 500 | A server error has occurred |\n| 404 | Invalid URL (not found) |\n| 429 | Too many requests |\n\nOther 4\\*\\* and 5\\*\\* response codes may also occur. Applications should always confirm that they received a 200 response before assuming success and processing the result.\n\nThe Cloud Service also returns information about the result in JSON or XML as follows:\n\n| **Field** | **Value** |\n| --- | --- |\n| Succeeded | &quot;true&quot; or &quot;false&quot;. |\n| shortMsg | A short message about the result. In the case of an error this will be a short error message. It may be blank in the case of a successful operation. |\n| longMsg | A more descriptive message about the result. In the case of an error this will be a long error message. It may be blank. |\n\nEach service may also return additional information in the response information, as indicated in the sections to follow.\n\nIn the case of some errors, the response body will NOT include the data structure containing &quot;succeeded&quot;, &quot;shortMsg&quot; etc. This is because some errors indicate the call failed to even reach the Cloud Service. For example, a status code 404 indicates a bad URL in which case the status code alone is enough to indicate the nature of the problem.\n\n\n## Troubleshooting\n\nThere are many resources available on the [Docmosis Resources website](https://resources.docmosis.com) including FAQs, examples and tutorials that may help with troubleshooting problems.\n# Important Render Parameters\n## Sending Data\n\nThe “data” parameter should contain the data, that will be merged with the template, in JSON or XML format.\n\n## Sending Data as Parameters\n\nBy default, only the parameters listed below should be included when calling the Render service. This is known as “strict” mode and sending unknown parameters to the service will result in an error.\n\nThe parameter \"strictParams\" can be set to \"false\" to disable this behavior.\n\nIn this case unknown parameters will be treated as data and will be merged with the template.\n\n## Output Format\n\nThe format of the generated document will be determined by:\n\n•\tThe parameter \"outputName\" and the file extension used in the file name. Eg “resume.pdf” will result in a PDF file being generated.\n\n•\tThe parameter \"outputFormat\".\n\nNote: the parameter \"outputFormat\" will override any format implied by \"outputName\".\n\n## Dev/Prod Mode\n\nThe Render service works in production mode by default.  Any errors that occur during the document generation process are considered fatal and the call will fail.\n\nThis may be overridden by setting the “devMode” parameter to “true”.  In this case the service will do its best to generate a document and where possible errors will be highlighted in the generated document.\n\n## Sending Images\n\nInserting an image in to a document requires two things:\n\n•\tThe template requires a “placeholder image”, that controls where the image will appear.\n\n•\tThe data determines what image is to appear.\n\nPlease refer to the [sending image data FAQ](https://resources.docmosis.com/content/faq/how-to-send-image-data-or-retrieve-images-from-a-file-or-url) for more information.\n\n## Document Delivery\n\nThe “storeTo” parameter controls how the generated document will be delivered.\n\nIf no value is provided for “storeTo”, the default behavior is “stream”. In this case the document will be returned in the response to the calling application. The calling application can read the returned binary or base64 encoded stream to obtain the document.\n\nThe service can deliver the generated document: via email; to an AWS S3 bucket; or to several destinations at once, and optionally send different formats for delivery to each destination.\n\nAs a simple example try setting “storeTo” to: “mailto:bob@example.com”. This indicates the generated document should be sent to the email address provided.\n",
    "termsOfService" : "https://www.docmosis.com/company/legal-privacy-policy/",
    "contact" : {
      "url" : "https://www.docmosis.com/support/"
    },
    "license" : {
      "name" : "Docmosis - Cloud Services Agreement",
      "url" : "https://www.docmosis.com/company/legal-privacy-policy/"
    },
    "version" : "dws4"
  },
  "externalDocs" : {
    "description" : "Cloud DWS4 Web Services Guide - This manual is intended to be a complete reference for software developers and integrators for making the most of Docmosis Cloud services. This manual covers the complete Docmosis Cloud services REST-based API.",
    "url" : "https://resources.docmosis.com/content/documentation/cloud-dws4-web-services-guide"
  },
  "servers" : [ {
    "url" : "https://us1.dws4.docmosis.com/api",
    "description" : "United States (N. Virginia)"
  }, {
    "url" : "https://au1.dws4.docmosis.com/api",
    "description" : "Australia (Sydney)"
  }, {
    "url" : "https://eu1.dws4.docmosis.com/api",
    "description" : "Europe (Frankfurt)"
  } ],
  "security" : [ {
    "accessKeyAuthorization" : [ ]
  } ],
  "tags" : [ {
    "name" : "Generate"
  }, {
    "name" : "Convert"
  }, {
    "name" : "Templates"
  }, {
    "name" : "Images"
  }, {
    "name" : "Admin"
  } ],
  "paths" : {
    "/environment/ready" : {
      "post" : {
        "tags" : [ "Admin" ],
        "summary" : "Environment Ready",
        "description" : "The Environment Ready service provides the ability to check whether an environment is ready to service document requests.  This service is suitable for linking to automated monitoring systems for important Docmosis Environments.\nThis service confirms whether the Environment is active and within quota limits. Note: Environments may be over quota (ie. hard limit is not applied) and still operational, in which case this service will indicate the environment is ready, even though over quota.\nConsider creating an API Key in the Environment specifically for use with this service.\nresponse code: 200 means ready\nresponse code: 400 means not ready",
        "operationId" : "accountEnvironmentReady",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/AccountReadyRequest"
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/AccountReadyRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "$ref" : "#/components/responses/200"
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/environment/ready \\\n--form 'accessKey='"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/environment/ready\");\n\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    System.out.println(EntityUtils.toString(response.getEntity()));\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/environment/ready\", content)) {\n    string responseString = await response.Content.ReadAsStringAsync();\n    Console.WriteLine(responseString);\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\naccessKey = ''\n\npayload = {\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/environment/ready', stream=True, data=payload)\n\nprint(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$accessKey = \"\";\n\n$request = array(\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/environment/ready\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\necho $response;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const formData = new FormData();\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/environment/ready\", options)\n    .then(response => {\n        return response.text().then(body => {\n            console.log(body);\n        })\n    });"
        } ]
      }
    },
    "/environment/summary" : {
      "post" : {
        "tags" : [ "Admin" ],
        "summary" : "Environment Summary",
        "description" : "The Environment Summary service returns details about an environment including plan information, status and quotas.  It is for information purposes and not intended for monitoring.\nNote: this service returns a 200 response even if the event is not ready which is different from the \"ready\" service endpoint.",
        "operationId" : "accountEnvironmentSummary",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/AccountSummaryRequest"
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/AccountSummaryRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "Request succeeded",
            "headers" : {
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              }
            },
            "content" : {
              "application/json" : {
                "schema" : {
                  "$ref" : "#/components/schemas/AccountSummaryResponse"
                },
                "examples" : {
                  "Example Response" : {
                    "description" : "Example Response",
                    "value" : {
                      "succeeded" : true,
                      "shortMsg" : "environment is ready",
                      "accountEnvironmentSummary" : {
                        "accountEnvDetails" : {
                          "auditInfo" : {
                            "lastUpdatedByUser" : "John Smith",
                            "lastUpdatedTime" : 1678334445203
                          },
                          "isActivated" : true,
                          "isDeleted" : false,
                          "isDisabled" : false,
                          "name" : "Development"
                        },
                        "pageQuota" : {
                          "isHardLimited" : false,
                          "pctUsed" : 20.0,
                          "pctUsedStr" : "20%",
                          "quota" : 5000,
                          "used" : 1000
                        },
                        "plan" : {
                          "name" : "Business-01"
                        },
                        "ready" : true
                      }
                    }
                  }
                }
              }
            }
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/environment/summary \\\n--form 'accessKey='"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/environment/summary\");\n\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    System.out.println(EntityUtils.toString(response.getEntity()));\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/environment/summary\", content)) {\n    string responseString = await response.Content.ReadAsStringAsync();\n    Console.WriteLine(responseString);\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\naccessKey = ''\n\npayload = {\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/environment/summary', stream=True, data=payload)\n\nprint(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$accessKey = \"\";\n\n$request = array(\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/environment/summary\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\necho $response;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const formData = new FormData();\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/environment/summary\", options)\n    .then(response => {\n        return response.text().then(body => {\n            console.log(body);\n        })\n    });"
        } ]
      }
    },
    "/ping" : {
      "get" : {
        "tags" : [ "Admin" ],
        "summary" : "Ping",
        "description" : "The Ping service provides a direct check that the Docmosis Cloud services are online and there is at least one Docmosis server listening. This is useful for diagnosing reachability issues. For automated monitoring purposes see the Environment Ready service.",
        "operationId" : "pingGet",
        "responses" : {
          "200" : {
            "description" : "Request succeeded"
          },
          "400" : {
            "description" : "Bad Request."
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "security" : [ ],
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request GET \\\n--url https://us1.dws4.docmosis.com/api/ping"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "URL url = new URL(\"https://us1.dws4.docmosis.com/api/ping\");\nHttpURLConnection connection = (HttpURLConnection) url.openConnection();\nconnection.setRequestMethod(\"GET\");\nSystem.out.println(connection.getResponseCode());"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\nusing (HttpResponseMessage response = await client.GetAsync(\"https://us1.dws4.docmosis.com/api/ping\")) {\nConsole.WriteLine(response.StatusCode);"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\nresponse = requests.get('https://us1.dws4.docmosis.com/api/ping')\nprint(response.status_code)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/ping\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 1);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n$httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);\n\ncurl_close($curl);\n\necho $httpcode;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "fetch(\"https://us1.dws4.docmosis.com/api/ping\")\n    .then(response => {\n        console.log(response.status);\n    });"
        } ]
      }
    },
    "/convert" : {
      "post" : {
        "tags" : [ "Convert" ],
        "summary" : "Convert",
        "description" : "The Convert service allows files to be converted between formats.  The process is a simple conversion with no concept of templates and data.  It applies to spreadsheet, presentation and drawing types of document.",
        "operationId" : "convert",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/ConvertRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "Request succeeded",
            "headers" : {
              "X-Docmosis-PagesRendered" : {
                "$ref" : "#/components/headers/X-Docmosis-PagesRendered"
              },
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              },
              "X-Docmosis-BytesOutput" : {
                "description" : "Number of bytes output.",
                "style" : "simple",
                "schema" : {
                  "type" : "string"
                }
              }
            },
            "content" : {
              "application/octet-stream" : {
                "schema" : {
                  "type" : "string",
                  "format" : "binary"
                }
              }
            }
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/convert \\\n--form 'file=@MyFile.docx' \\\n--form 'outputName=output.pdf' \\\n--form 'accessKey=' \\\n--output 'output.pdf'"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/convert\");\n\nFile file = new File(\"MyFile.docx\");\nString outputName = \"output.pdf\";\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addBinaryBody(\"file\", file);\nbuilder.addTextBody(\"outputName\", outputName);\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    if (response.getCode() == HttpStatus.SC_OK) {\n        File outputFile = new File(\"output.pdf\");\n        FileOutputStream outstream = new FileOutputStream(outputFile);\n        response.getEntity().writeTo(outstream);\n        System.out.println(\"File saved to:\" + outputFile.getAbsolutePath());\n    } else {\n        System.out.println(EntityUtils.toString(response.getEntity()));\n    }\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nFileInfo file = new FileInfo(\"MyFile.docx\");\nstring outputName = \"output.pdf\";\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StreamContent(file.OpenRead()), \"file\", file.Name);\ncontent.Add(new StringContent(outputName), \"outputName\");\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/convert\", content)) {\n    if (response.StatusCode == HttpStatusCode.OK) {\n        using (FileStream outputFile = File.Create(\"output.pdf\")) {\n            using (Stream outputStream = await response.Content.ReadAsStreamAsync()) {\n                await outputStream.CopyToAsync(outputFile);\n                Console.WriteLine(\"File saved to:\" + outputFile.Name);\n            }\n        }\n    } else {\n        string responseString = await response.Content.ReadAsStringAsync();\n        Console.WriteLine(responseString);\n    }\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\nfile = 'MyFile.docx'\noutputName = 'output.pdf'\naccessKey = ''\n\npayload = {\n    'outputName' : outputName,\n    'accessKey' : accessKey\n}\n\nfiles = {'file': open(file, 'rb')}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/convert', stream=True, data=payload, files=files)\n\nif response.status_code == 200:\n    with open('output.pdf', 'wb') as fd:\n        for chunk in response.iter_content(4096):\n            fd.write(chunk)\n    print('Saved to output.pdf')\nelse:\n    print(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$file = curl_file_create(\"full/path/to/MyFile.docx\", null, \"MyFile.docx\");\n$outputName = \"output.pdf\";\n$accessKey = \"\";\n\n$request = array(\n    \"file\" => $file,\n    \"outputName\" => $outputName,\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/convert\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\nif ($status === 200) {\n    $outputFile = file_put_contents(\"output.pdf\", $response);\n    echo \"Saved to output.pdf\";\n} else {\n    echo $response;\n}\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const fs = require(\"fs\");\nconst { Readable } = require(\"node:stream\");\n\nconst formData = new FormData();\nformData.append(\"file\", new Blob([fs.readFileSync(\"MyFile.docx\")]));\nformData.append(\"outputName\", \"output.pdf\");\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/convert\", options)\n    .then(response => {\n        if (response.ok) {\n            const destination = fs.createWriteStream(\"output.pdf\");\n            Readable.fromWeb(response.body).pipe(destination);\n            console.log(\"Saved to output.pdf\");\n        } else {\n            return response.text().then(body => {\n                console.log(body);\n            })\n        }\n    });"
        } ]
      }
    },
    "/deleteImage" : {
      "post" : {
        "tags" : [ "Images" ],
        "summary" : "Delete Image",
        "description" : "The Delete Image service deletes the specified image.  Multiple imageName parameters can be specified to delete multiple images.",
        "operationId" : "deleteImage",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/DeleteImageRequest"
              },
              "encoding" : {
                "imageName" : {
                  "explode" : true
                }
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/DeleteImageRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "$ref" : "#/components/responses/200"
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/deleteImage \\\n--form 'imageName=/MyImageFolder/MyImage.png' \\\n--form 'accessKey='"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/deleteImage\");\n\nString[] imageName = new String[] {\"/MyImageFolder/MyImage.png\"};\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"imageName\", imageName[0]);\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    System.out.println(EntityUtils.toString(response.getEntity()));\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring[] imageName = new string[] {\"/MyImageFolder/MyImage.png\"};\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(imageName[0]), \"imageName\");\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/deleteImage\", content)) {\n    string responseString = await response.Content.ReadAsStringAsync();\n    Console.WriteLine(responseString);\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\nimageName = [ '/MyImageFolder/MyImage.png' ]\naccessKey = ''\n\npayload = {\n    'imageName' : imageName[0],\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/deleteImage', stream=True, data=payload)\n\nprint(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$imageName = array( \"/MyImageFolder/MyImage.png\" );\n$accessKey = \"\";\n\n$request = array(\n    \"imageName\" => $imageName[0],\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/deleteImage\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\necho $response;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const formData = new FormData();\nformData.append(\"imageName\", \"/MyImageFolder/MyImage.png\");\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/deleteImage\", options)\n    .then(response => {\n        return response.text().then(body => {\n            console.log(body);\n        })\n    });"
        } ]
      }
    },
    "/getImage" : {
      "post" : {
        "tags" : [ "Images" ],
        "summary" : "Get Image",
        "description" : "The Get Image service retrieves the image that was originally uploaded.  Multiple imageName parameters can be specified to download in a zip file (up to 100).",
        "operationId" : "getImage",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/GetImageRequest"
              },
              "encoding" : {
                "imageName" : {
                  "explode" : true
                }
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/GetImageRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "The body of the response will contain the binary stream for the image. A zip is returned if requesting multiple images.",
            "headers" : {
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              }
            },
            "content" : {
              "application/octet-stream" : {
                "schema" : {
                  "type" : "string",
                  "format" : "binary"
                }
              }
            }
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/getImage \\\n--form 'imageName=/MyImageFolder/MyImage.png' \\\n--form 'accessKey=' \\\n--output 'MyImage.png'"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/getImage\");\n\nString[] imageName = new String[] {\"/MyImageFolder/MyImage.png\"};\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"imageName\", imageName[0]);\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    if (response.getCode() == HttpStatus.SC_OK) {\n        File outputFile = new File(\"MyImage.png\");\n        FileOutputStream outstream = new FileOutputStream(outputFile);\n        response.getEntity().writeTo(outstream);\n        System.out.println(\"File saved to:\" + outputFile.getAbsolutePath());\n    } else {\n        System.out.println(EntityUtils.toString(response.getEntity()));\n    }\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring[] imageName = new string[] {\"/MyImageFolder/MyImage.png\"};\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(imageName[0]), \"imageName\");\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/getImage\", content)) {\n    if (response.StatusCode == HttpStatusCode.OK) {\n        using (FileStream outputFile = File.Create(\"MyImage.png\")) {\n            using (Stream outputStream = await response.Content.ReadAsStreamAsync()) {\n                await outputStream.CopyToAsync(outputFile);\n                Console.WriteLine(\"File saved to:\" + outputFile.Name);\n            }\n        }\n    } else {\n        string responseString = await response.Content.ReadAsStringAsync();\n        Console.WriteLine(responseString);\n    }\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\nimageName = [ '/MyImageFolder/MyImage.png' ]\naccessKey = ''\n\npayload = {\n    'imageName' : imageName[0],\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/getImage', stream=True, data=payload)\n\nif response.status_code == 200:\n    with open('MyImage.png', 'wb') as fd:\n        for chunk in response.iter_content(4096):\n            fd.write(chunk)\n    print('Saved to MyImage.png')\nelse:\n    print(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$imageName = array( \"/MyImageFolder/MyImage.png\" );\n$accessKey = \"\";\n\n$request = array(\n    \"imageName\" => $imageName[0],\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/getImage\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\nif ($status === 200) {\n    $outputFile = file_put_contents(\"MyImage.png\", $response);\n    echo \"Saved to MyImage.png\";\n} else {\n    echo $response;\n}\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const fs = require(\"fs\");\nconst { Readable } = require(\"node:stream\");\n\nconst formData = new FormData();\nformData.append(\"imageName\", \"/MyImageFolder/MyImage.png\");\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/getImage\", options)\n    .then(response => {\n        if (response.ok) {\n            const destination = fs.createWriteStream(\"MyImage.png\");\n            Readable.fromWeb(response.body).pipe(destination);\n            console.log(\"Saved to MyImage.png\");\n        } else {\n            return response.text().then(body => {\n                console.log(body);\n            })\n        }\n    });"
        } ]
      }
    },
    "/listImages" : {
      "post" : {
        "tags" : [ "Images" ],
        "summary" : "List Images",
        "description" : "The List Images service lists the images available.",
        "operationId" : "listImage",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/ListImagesRequest"
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/ListImagesRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "Request succeeded",
            "headers" : {
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              }
            },
            "content" : {
              "application/json" : {
                "schema" : {
                  "$ref" : "#/components/schemas/ListImagesResponse"
                }
              }
            }
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/listImages \\\n--form 'accessKey='"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/listImages\");\n\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    System.out.println(EntityUtils.toString(response.getEntity()));\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/listImages\", content)) {\n    string responseString = await response.Content.ReadAsStringAsync();\n    Console.WriteLine(responseString);\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\naccessKey = ''\n\npayload = {\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/listImages', stream=True, data=payload)\n\nprint(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$accessKey = \"\";\n\n$request = array(\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/listImages\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\necho $response;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const formData = new FormData();\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/listImages\", options)\n    .then(response => {\n        return response.text().then(body => {\n            console.log(body);\n        })\n    });"
        } ]
      }
    },
    "/uploadImage" : {
      "post" : {
        "tags" : [ "Images" ],
        "summary" : "Upload Image",
        "description" : "The Upload Image service works the same as the Upload Template service, but is significantly simpler since there are few options to set.  \n\nUploading images creates \"stock\" images that data can reference when generating documents and Docmosis will take care of placing them into the document.  This saves bandwidth and time when rendering the same images frequently.  An alternative to uploading \"stock\" images is to place the images into the template and selectively filter them out using conditional sections.",
        "operationId" : "uploadImage",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/UploadImageRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "The response is an indicator of success or failure plus any further helpful information.  When the upload is successful, details are returned under the “imageDetails” key.",
            "headers" : {
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              }
            },
            "content" : {
              "application/json" : {
                "schema" : {
                  "$ref" : "#/components/schemas/UploadImageResponse"
                }
              }
            }
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/uploadImage \\\n--form 'imageFile=@MyImage.png' \\\n--form 'accessKey='"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/uploadImage\");\n\nFile imageFile = new File(\"MyImage.png\");\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addBinaryBody(\"imageFile\", imageFile);\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    System.out.println(EntityUtils.toString(response.getEntity()));\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nFileInfo imageFile = new FileInfo(\"MyImage.png\");\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StreamContent(imageFile.OpenRead()), \"imageFile\", imageFile.Name);\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/uploadImage\", content)) {\n    string responseString = await response.Content.ReadAsStringAsync();\n    Console.WriteLine(responseString);\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\nimageFile = 'MyImage.png'\naccessKey = ''\n\npayload = {\n    'accessKey' : accessKey\n}\n\nfiles = {'imageFile': open(imageFile, 'rb')}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/uploadImage', stream=True, data=payload, files=files)\n\nprint(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$imageFile = curl_file_create(\"full/path/to/MyImage.png\", null, \"MyImage.png\");\n$accessKey = \"\";\n\n$request = array(\n    \"imageFile\" => $imageFile,\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/uploadImage\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\necho $response;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const fs = require(\"fs\");\nconst { Readable } = require(\"node:stream\");\n\nconst formData = new FormData();\nformData.append(\"imageFile\", new Blob([fs.readFileSync(\"MyImage.png\")]));\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/uploadImage\", options)\n    .then(response => {\n        return response.text().then(body => {\n            console.log(body);\n        })\n    });"
        } ]
      }
    },
    "/render" : {
      "post" : {
        "tags" : [ "Generate" ],
        "summary" : "Render",
        "description" : "The Render service is the document generation ‘work-horse’, and it is expected to be the main service that will be used. \nApplications call the Render service with data and instructions indicating: which template to use, the formats required, where to send the result, and more.\n\nSee notes above for more details on important parameters.\n",
        "operationId" : "render",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/RenderRequest"
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/RenderRequest"
              },
              "examples" : {
                "JSON Render to File" : {
                  "description" : "Example JSON Render Request which returns a file",
                  "value" : {
                    "accessKey" : "",
                    "templateName" : "/WelcomeTemplate.docx",
                    "outputName" : "output.pdf",
                    "data" : {
                      "title" : "Hello from OpenApi",
                      "messages" : [ {
                        "msg" : "This cloud experience is better than I thought."
                      }, {
                        "msg" : "The sun is shining."
                      }, {
                        "msg" : "Right, now back to work."
                      } ]
                    }
                  }
                },
                "JSON Render to S3 Bucket" : {
                  "description" : "Example JSON Render Request which stores the result in an S3 Bucket",
                  "value" : {
                    "accessKey" : "",
                    "templateName" : "/WelcomeTemplate.docx",
                    "outputName" : "output.pdf",
                    "storeTo" : "s3:my.amazon.bucket,mydocument1.pdf",
                    "data" : {
                      "title" : "Hello from OpenApi",
                      "messages" : [ {
                        "msg" : "This cloud experience is better than I thought."
                      }, {
                        "msg" : "The sun is shining."
                      }, {
                        "msg" : "Right, now back to work."
                      } ]
                    }
                  }
                },
                "JSON Render to Email" : {
                  "description" : "Example JSON Render Request which sends the result via email",
                  "value" : {
                    "accessKey" : "",
                    "templateName" : "/WelcomeTemplate.docx",
                    "outputName" : "output.pdf",
                    "storeTo" : "mailto:email@example.com",
                    "mailSubject" : "Email from Docmosis Web Services",
                    "mailBodyText" : "Hi You,\n\nPlease find attached your rendered Document from Docmosis Web Services.\n\nHave a nice day!\n\nRegards,\nDocmosis",
                    "data" : {
                      "title" : "Hello from OpenApi",
                      "messages" : [ {
                        "msg" : "This cloud experience is better than I thought."
                      }, {
                        "msg" : "The sun is shining."
                      }, {
                        "msg" : "Right, now back to work."
                      } ]
                    }
                  }
                }
              }
            },
            "application/xml" : {
              "schema" : {
                "$ref" : "#/components/schemas/RenderRequest"
              },
              "examples" : {
                "XML Render to File" : {
                  "description" : "Example XML Render Request which returns a file",
                  "value" : "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<render accessKey=\"\" templateName=\"/WelcomeTemplate.docx\" outputName=\"output.pdf\">\n  <data>\n    <title>Hello from OpenApi</title>\n    <messages>\n      <msg>This cloud experience is better than I thought.</msg>\n    </messages>\n    <messages>\n      <msg>The sun is shining.</msg>\n    </messages>\n    <messages>\n      <msg>Right, now back to work.</msg>\n    </messages>\n  </data>\n</render>"
                },
                "XML Render to S3 Bucket" : {
                  "description" : "Example XML Render Request which stores the result in an S3 Bucket",
                  "value" : "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<render accessKey=\"\" templateName=\"/WelcomeTemplate.docx\" outputName=\"output.pdf\" storeTo=\"s3:my.amazon.bucket,mydocument1.pdf\">\n  <data>\n    <title>Hello from OpenApi</title>\n    <messages>\n      <msg>This cloud experience is better than I thought.</msg>\n    </messages>\n    <messages>\n      <msg>The sun is shining.</msg>\n    </messages>\n    <messages>\n      <msg>Right, now back to work.</msg>\n    </messages>\n  </data>\n</render>"
                },
                "XML Render to Email" : {
                  "description" : "Example XML Render Request which sends the result via email",
                  "value" : "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<render accessKey=\"\" templateName=\"/WelcomeTemplate.docx\" outputName=\"output.pdf\" storeTo=\"mailto:email@example.com\" mailSubject=\"Email from Docmosis Web Services\"><mailBodyText>Hi You,\n\nPlease find attached your rendered Document from Docmosis Web Services.\n\nHave a nice day!\n\nRegards,\nDocmosis</mailBodyText>\n  <data>\n    <title>Hello from OpenApi</title>\n    <messages>\n      <msg>This cloud experience is better than I thought.</msg>\n    </messages>\n    <messages>\n      <msg>The sun is shining.</msg>\n    </messages>\n    <messages>\n      <msg>Right, now back to work.</msg>\n    </messages>\n  </data>\n</render>"
                }
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "If storeTo includes \"stream\" then the body of the response is the binary document stream. If storeTo excludes \"stream\" then the body of the response is a JSON or XML object.",
            "headers" : {
              "X-Docmosis-PagesRendered" : {
                "$ref" : "#/components/headers/X-Docmosis-PagesRendered"
              },
              "X-Docmosis-Zip-Created" : {
                "$ref" : "#/components/headers/X-Docmosis-Zip-Created"
              },
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              },
              "X-Docmosis-Document-Errors-Detected" : {
                "$ref" : "#/components/headers/X-Docmosis-Document-Errors-Detected"
              },
              "Retry-After" : {
                "$ref" : "#/components/headers/Retry-After"
              },
              "X-Docmosis-Queue-Available-Pct" : {
                "$ref" : "#/components/headers/X-Docmosis-Queue-Available-Pct"
              },
              "X-Docmosis-Queue-Rejected" : {
                "$ref" : "#/components/headers/X-Docmosis-Queue-Rejected"
              },
              "X-Docmosis-Queue-Delay-Seconds" : {
                "$ref" : "#/components/headers/X-Docmosis-Queue-Delay-Seconds"
              },
              "X-Docmosis-RequestId" : {
                "$ref" : "#/components/headers/X-Docmosis-RequestId"
              }
            },
            "content" : {
              "application/octet-stream" : {
                "schema" : {
                  "type" : "string",
                  "format" : "binary"
                }
              },
              "application/json" : {
                "schema" : {
                  "oneOf" : [ {
                    "$ref" : "#/components/schemas/Response"
                  }, {
                    "$ref" : "#/components/schemas/RenderResponse"
                  } ]
                }
              },
              "application/xml" : {
                "schema" : {
                  "oneOf" : [ {
                    "$ref" : "#/components/schemas/Response"
                  }, {
                    "$ref" : "#/components/schemas/RenderResponse"
                  } ]
                }
              }
            }
          },
          "400" : {
            "description" : "Bad Request.",
            "headers" : {
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              },
              "Retry-After" : {
                "$ref" : "#/components/headers/Retry-After"
              },
              "X-Docmosis-Queue-Available-Pct" : {
                "$ref" : "#/components/headers/X-Docmosis-Queue-Available-Pct"
              },
              "X-Docmosis-Queue-Rejected" : {
                "$ref" : "#/components/headers/X-Docmosis-Queue-Rejected"
              },
              "X-Docmosis-Queue-Delay-Seconds" : {
                "$ref" : "#/components/headers/X-Docmosis-Queue-Delay-Seconds"
              },
              "X-Docmosis-RequestId" : {
                "$ref" : "#/components/headers/X-Docmosis-RequestId"
              }
            },
            "content" : {
              "application/json" : {
                "schema" : {
                  "oneOf" : [ {
                    "$ref" : "#/components/schemas/Response"
                  }, {
                    "$ref" : "#/components/schemas/RenderResponse"
                  } ]
                }
              },
              "application/xml" : {
                "schema" : {
                  "oneOf" : [ {
                    "$ref" : "#/components/schemas/Response"
                  }, {
                    "$ref" : "#/components/schemas/RenderResponse"
                  } ]
                }
              }
            }
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/render \\\n--header 'Content-Type: application/json' \\\n--data '\n{\n  \"outputName\": \"output.pdf\",\n  \"templateName\": \"/WelcomeTemplate.docx\",\n  \"data\": {\n    \"title\": \"Hello from OpenApi\",\n    \"messages\": [\n      {\n        \"msg\": \"This cloud experience is better than I thought.\"\n      },\n      {\n        \"msg\": \"The sun is shining.\"\n      },\n      {\n        \"msg\": \"Right, now back to work.\"\n      }\n    ]\n  },\n  \"accessKey\": \"\"\n}\n' \\\n--output 'output.pdf'"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/render\");\nrequest.addHeader(\"content-type\", \"application/json\");\n\nString json = \n\"{\" +\n \"  \\\"outputName\\\": \\\"output.pdf\\\",\" +\n \"  \\\"templateName\\\": \\\"/WelcomeTemplate.docx\\\",\" +\n \"  \\\"data\\\": {\" +\n \"    \\\"title\\\": \\\"Hello from OpenApi\\\",\" +\n \"    \\\"messages\\\": [\" +\n \"      {\" +\n \"        \\\"msg\\\": \\\"This cloud experience is better than I thought.\\\"\" +\n \"      },\" +\n \"      {\" +\n \"        \\\"msg\\\": \\\"The sun is shining.\\\"\" +\n \"      },\" +\n \"      {\" +\n \"        \\\"msg\\\": \\\"Right, now back to work.\\\"\" +\n \"      }\" +\n \"    ]\" +\n \"  },\" +\n \"  \\\"accessKey\\\": \\\"\\\"\" +\n \"}\";\nHttpEntity payLoad = new StringEntity(json);\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    if (response.getCode() == HttpStatus.SC_OK) {\n        File outputFile = new File(\"output.pdf\");\n        FileOutputStream outstream = new FileOutputStream(outputFile);\n        response.getEntity().writeTo(outstream);\n        System.out.println(\"File saved to:\" + outputFile.getAbsolutePath());\n    } else {\n        System.out.println(EntityUtils.toString(response.getEntity()));\n    }\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring json = \n\"{\" +\n \"  \\\"outputName\\\": \\\"output.pdf\\\",\" +\n \"  \\\"templateName\\\": \\\"/WelcomeTemplate.docx\\\",\" +\n \"  \\\"data\\\": {\" +\n \"    \\\"title\\\": \\\"Hello from OpenApi\\\",\" +\n \"    \\\"messages\\\": [\" +\n \"      {\" +\n \"        \\\"msg\\\": \\\"This cloud experience is better than I thought.\\\"\" +\n \"      },\" +\n \"      {\" +\n \"        \\\"msg\\\": \\\"The sun is shining.\\\"\" +\n \"      },\" +\n \"      {\" +\n \"        \\\"msg\\\": \\\"Right, now back to work.\\\"\" +\n \"      }\" +\n \"    ]\" +\n \"  },\" +\n \"  \\\"accessKey\\\": \\\"\\\"\" +\n \"}\";\n\nStringContent content = new StringContent(json, Encoding.UTF8, \"application/json\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/render\", content)) {\n    if (response.StatusCode == HttpStatusCode.OK) {\n        using (FileStream outputFile = File.Create(\"output.pdf\")) {\n            using (Stream outputStream = await response.Content.ReadAsStreamAsync()) {\n                await outputStream.CopyToAsync(outputFile);\n                Console.WriteLine(\"File saved to:\" + outputFile.Name);\n            }\n        }\n    } else {\n        string responseString = await response.Content.ReadAsStringAsync();\n        Console.WriteLine(responseString);\n    }\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\njson = {\n  'outputName': 'output.pdf',\n  'templateName': '/WelcomeTemplate.docx',\n  'data': {\n    'title': 'Hello from OpenApi',\n    'messages': [\n      {\n        'msg': 'This cloud experience is better than I thought.'\n      },\n      {\n        'msg': 'The sun is shining.'\n      },\n      {\n        'msg': 'Right, now back to work.'\n      }\n    ]\n  },\n  'accessKey': ''\n}\n\nheaders = {'content-type': 'application/json'}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/render', stream=True, headers=headers, json=json)\n\nif response.status_code == 200:\n    with open('output.pdf', 'wb') as fd:\n        for chunk in response.iter_content(4096):\n            fd.write(chunk)\n    print('Saved to output.pdf')\nelse:\n    print(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$json = json_decode('{\n  \"outputName\": \"output.pdf\",\n  \"templateName\": \"/WelcomeTemplate.docx\",\n  \"data\": {\n    \"title\": \"Hello from OpenApi\",\n    \"messages\": [\n      {\n        \"msg\": \"This cloud experience is better than I thought.\"\n      },\n      {\n        \"msg\": \"The sun is shining.\"\n      },\n      {\n        \"msg\": \"Right, now back to work.\"\n      }\n    ]\n  },\n  \"accessKey\": \"\"\n}');\n\n$request = json_encode($json);\n\n$headers = array(\"Content-Type: application/json\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/render\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\nif ($status === 200) {\n    $outputFile = file_put_contents(\"output.pdf\", $response);\n    echo \"Saved to output.pdf\";\n} else {\n    echo $response;\n}\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const fs = require(\"fs\");\nconst { Readable } = require(\"node:stream\");\n\nconst options = {\n    method: \"POST\",\n    headers: {\n        \"Content-Type\": \"application/json\"\n    },\n    body : JSON.stringify({\n        outputName : \"output.pdf\",\n        templateName : \"/WelcomeTemplate.docx\",\n        data : {\n              \"title\": \"Hello from OpenApi\",\n              \"messages\": [\n                {\n                  \"msg\": \"This cloud experience is better than I thought.\"\n                },\n                {\n                  \"msg\": \"The sun is shining.\"\n                },\n                {\n                  \"msg\": \"Right, now back to work.\"\n                }\n              ]\n            },\n        accessKey : \"\"\n    })\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/render\", options)\n    .then(response => {\n        if (response.ok) {\n            const destination = fs.createWriteStream(\"output.pdf\");\n            Readable.fromWeb(response.body).pipe(destination);\n            console.log(\"Saved to output.pdf\");\n        } else {\n            return response.text().then(body => {\n                console.log(body);\n            })\n        }\n    });"
        } ]
      }
    },
    "/getRenderQueue" : {
      "post" : {
        "tags" : [ "Admin" ],
        "summary" : "Get Render Queue",
        "description" : "The Get Render Queue service returns info about the current status of the render queue for the specified Environment.",
        "operationId" : "getRenderQueue",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/RenderQueueRequest"
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/RenderQueueRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "Request succeeded",
            "headers" : {
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              },
              "X-Docmosis-Queue-Available-Pct" : {
                "$ref" : "#/components/headers/X-Docmosis-Queue-Available-Pct"
              },
              "X-Docmosis-Queue-Delay-Seconds" : {
                "$ref" : "#/components/headers/X-Docmosis-Queue-Delay-Seconds"
              }
            },
            "content" : {
              "application/json" : {
                "schema" : {
                  "$ref" : "#/components/schemas/RenderQueueResponse"
                }
              }
            }
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/getRenderQueue \\\n--form 'accessKey='"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/getRenderQueue\");\n\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    System.out.println(EntityUtils.toString(response.getEntity()));\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/getRenderQueue\", content)) {\n    string responseString = await response.Content.ReadAsStringAsync();\n    Console.WriteLine(responseString);\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\naccessKey = ''\n\npayload = {\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/getRenderQueue', stream=True, data=payload)\n\nprint(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$accessKey = \"\";\n\n$request = array(\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/getRenderQueue\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\necho $response;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const formData = new FormData();\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/getRenderQueue\", options)\n    .then(response => {\n        return response.text().then(body => {\n            console.log(body);\n        })\n    });"
        } ]
      }
    },
    "/getRenderTags" : {
      "post" : {
        "tags" : [ "Admin" ],
        "summary" : "Get Render Tags",
        "description" : "The Get Render Tags service allows statistics to be retrieved on renders that were tagged with user-defined phrases (“tags”).   The statistics include page counts and document counts that have been collected against the tags, aggregated monthly.  This may be useful for reporting the level of activity of a group of users, or a feature.",
        "operationId" : "getRenderTags",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/GetRenderTagsRequest"
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/GetRenderTagsRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "Request succeeded",
            "headers" : {
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              }
            },
            "content" : {
              "application/json" : {
                "schema" : {
                  "$ref" : "#/components/schemas/GetRenderTagsResponse"
                },
                "examples" : {
                  "Example Response" : {
                    "description" : "Example Response",
                    "value" : {
                      "succeeded" : true,
                      "renderTags" : [ {
                        "year" : "2017",
                        "month" : "8",
                        "tags" : [ {
                          "name" : "abc",
                          "countPages" : "0",
                          "countDocuments" : "0"
                        }, {
                          "name" : "def",
                          "countPages" : "0",
                          "countDocuments" : "0"
                        }, {
                          "name" : "abc;def",
                          "countPages" : "0",
                          "countDocuments" : "0"
                        } ]
                      }, {
                        "year" : "2017",
                        "month" : "9",
                        "tags" : [ {
                          "name" : "abc",
                          "countPages" : "6",
                          "countDocuments" : "4"
                        }, {
                          "name" : "def",
                          "countPages" : "4",
                          "countDocuments" : "2"
                        }, {
                          "name" : "abc;def",
                          "countPages" : "2",
                          "countDocuments" : "1"
                        } ]
                      } ]
                    }
                  }
                }
              }
            }
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/getRenderTags \\\n--form 'tags=abc;def' \\\n--form 'accessKey='"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/getRenderTags\");\n\nString tags = \"abc;def\";\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"tags\", tags);\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    System.out.println(EntityUtils.toString(response.getEntity()));\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring tags = \"abc;def\";\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(tags), \"tags\");\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/getRenderTags\", content)) {\n    string responseString = await response.Content.ReadAsStringAsync();\n    Console.WriteLine(responseString);\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\ntags = 'abc;def'\naccessKey = ''\n\npayload = {\n    'tags' : tags,\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/getRenderTags', stream=True, data=payload)\n\nprint(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$tags = \"abc;def\";\n$accessKey = \"\";\n\n$request = array(\n    \"tags\" => $tags,\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/getRenderTags\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\necho $response;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const formData = new FormData();\nformData.append(\"tags\", \"abc;def\");\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/getRenderTags\", options)\n    .then(response => {\n        return response.text().then(body => {\n            console.log(body);\n        })\n    });"
        } ]
      }
    },
    "/deleteTemplate" : {
      "post" : {
        "tags" : [ "Templates" ],
        "summary" : "Delete Template",
        "description" : "The Delete Template service deletes the specified template.  Multiple templateName parameters can be specified to delete multiple templates.",
        "operationId" : "deleteTemplate",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/DeleteTemplateRequest"
              },
              "encoding" : {
                "templateName" : {
                  "explode" : true
                }
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/DeleteTemplateRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "$ref" : "#/components/responses/200"
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/deleteTemplate \\\n--form 'templateName=/MyFolder/MyTemplate.docx' \\\n--form 'accessKey='"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/deleteTemplate\");\n\nString[] templateName = new String[] {\"/MyFolder/MyTemplate.docx\"};\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"templateName\", templateName[0]);\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    System.out.println(EntityUtils.toString(response.getEntity()));\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring[] templateName = new string[] {\"/MyFolder/MyTemplate.docx\"};\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(templateName[0]), \"templateName\");\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/deleteTemplate\", content)) {\n    string responseString = await response.Content.ReadAsStringAsync();\n    Console.WriteLine(responseString);\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\ntemplateName = [ '/MyFolder/MyTemplate.docx' ]\naccessKey = ''\n\npayload = {\n    'templateName' : templateName[0],\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/deleteTemplate', stream=True, data=payload)\n\nprint(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$templateName = array( \"/MyFolder/MyTemplate.docx\" );\n$accessKey = \"\";\n\n$request = array(\n    \"templateName\" => $templateName[0],\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/deleteTemplate\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\necho $response;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const formData = new FormData();\nformData.append(\"templateName\", \"/MyFolder/MyTemplate.docx\");\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/deleteTemplate\", options)\n    .then(response => {\n        return response.text().then(body => {\n            console.log(body);\n        })\n    });"
        } ]
      }
    },
    "/getTemplateDetails" : {
      "post" : {
        "tags" : [ "Templates" ],
        "summary" : "Get Template Details",
        "description" : "The Get Template Details service retrieves the details of a template that was originally uploaded, but not the template itself.",
        "operationId" : "getTemplateDetails",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/GetTemplateDetailsRequest"
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/GetTemplateDetailsRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "Request succeeded",
            "headers" : {
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              }
            },
            "content" : {
              "application/json" : {
                "schema" : {
                  "$ref" : "#/components/schemas/GetTemplateDetailsResponse"
                }
              }
            }
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/getTemplateDetails \\\n--form 'templateName=/WelcomeTemplate.docx' \\\n--form 'accessKey='"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/getTemplateDetails\");\n\nString templateName = \"/WelcomeTemplate.docx\";\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"templateName\", templateName);\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    System.out.println(EntityUtils.toString(response.getEntity()));\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring templateName = \"/WelcomeTemplate.docx\";\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(templateName), \"templateName\");\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/getTemplateDetails\", content)) {\n    string responseString = await response.Content.ReadAsStringAsync();\n    Console.WriteLine(responseString);\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\ntemplateName = '/WelcomeTemplate.docx'\naccessKey = ''\n\npayload = {\n    'templateName' : templateName,\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/getTemplateDetails', stream=True, data=payload)\n\nprint(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$templateName = \"/WelcomeTemplate.docx\";\n$accessKey = \"\";\n\n$request = array(\n    \"templateName\" => $templateName,\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/getTemplateDetails\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\necho $response;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const formData = new FormData();\nformData.append(\"templateName\", \"/WelcomeTemplate.docx\");\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/getTemplateDetails\", options)\n    .then(response => {\n        return response.text().then(body => {\n            console.log(body);\n        })\n    });"
        } ]
      }
    },
    "/getTemplate" : {
      "post" : {
        "tags" : [ "Templates" ],
        "summary" : "Get Template",
        "description" : "The Get Template service retrieves the template that was originally uploaded.\n\nMultiple templateName parameters can be specified to download multiple templates in one zip response (up to 100 in one request).",
        "operationId" : "getTemplate",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/GetTemplateRequest"
              },
              "encoding" : {
                "templateName" : {
                  "explode" : true
                }
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/GetTemplateRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "The body of the response will contain the binary stream for the template. A zip is returned if requesting multiple templates.",
            "headers" : {
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              }
            },
            "content" : {
              "application/octet-stream" : {
                "schema" : {
                  "type" : "string",
                  "format" : "binary"
                }
              }
            }
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/getTemplate \\\n--form 'templateName=/WelcomeTemplate.docx' \\\n--form 'accessKey=' \\\n--output 'MyTemplate.docx'"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/getTemplate\");\n\nString[] templateName = new String[] {\"/WelcomeTemplate.docx\"};\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"templateName\", templateName[0]);\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    if (response.getCode() == HttpStatus.SC_OK) {\n        File outputFile = new File(\"MyTemplate.docx\");\n        FileOutputStream outstream = new FileOutputStream(outputFile);\n        response.getEntity().writeTo(outstream);\n        System.out.println(\"File saved to:\" + outputFile.getAbsolutePath());\n    } else {\n        System.out.println(EntityUtils.toString(response.getEntity()));\n    }\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring[] templateName = new string[] {\"/WelcomeTemplate.docx\"};\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(templateName[0]), \"templateName\");\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/getTemplate\", content)) {\n    if (response.StatusCode == HttpStatusCode.OK) {\n        using (FileStream outputFile = File.Create(\"MyTemplate.docx\")) {\n            using (Stream outputStream = await response.Content.ReadAsStreamAsync()) {\n                await outputStream.CopyToAsync(outputFile);\n                Console.WriteLine(\"File saved to:\" + outputFile.Name);\n            }\n        }\n    } else {\n        string responseString = await response.Content.ReadAsStringAsync();\n        Console.WriteLine(responseString);\n    }\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\ntemplateName = [ '/WelcomeTemplate.docx' ]\naccessKey = ''\n\npayload = {\n    'templateName' : templateName[0],\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/getTemplate', stream=True, data=payload)\n\nif response.status_code == 200:\n    with open('MyTemplate.docx', 'wb') as fd:\n        for chunk in response.iter_content(4096):\n            fd.write(chunk)\n    print('Saved to MyTemplate.docx')\nelse:\n    print(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$templateName = array( \"/WelcomeTemplate.docx\" );\n$accessKey = \"\";\n\n$request = array(\n    \"templateName\" => $templateName[0],\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/getTemplate\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\nif ($status === 200) {\n    $outputFile = file_put_contents(\"MyTemplate.docx\", $response);\n    echo \"Saved to MyTemplate.docx\";\n} else {\n    echo $response;\n}\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
          "source" : "const fs = require(\"fs\");\nconst { Readable } = require(\"node:stream\");\n\nconst formData = new FormData();\nformData.append(\"templateName\", \"/WelcomeTemplate.docx\");\nformData.append(\"accessKey\", \"\");\n\nconst options = {\n    method: \"POST\",\n    body : formData\n};\n\nfetch(\"https://us1.dws4.docmosis.com/api/getTemplate\", options)\n    .then(response => {\n        if (response.ok) {\n            const destination = fs.createWriteStream(\"MyTemplate.docx\");\n            Readable.fromWeb(response.body).pipe(destination);\n            console.log(\"Saved to MyTemplate.docx\");\n        } else {\n            return response.text().then(body => {\n                console.log(body);\n            })\n        }\n    });"
        } ]
      }
    },
    "/getSampleData" : {
      "post" : {
        "tags" : [ "Generate" ],
        "summary" : "Get Sample Data",
        "description" : "The Get Sample Data service allows sample data to be generated for a template based on the current structures in the template. The sample data can be created in JSON or XML format which can then be fed back to the Render service to generate populated documents.\n\nThe service creates values like “value1”, “value2” for each field element.\n\nIf the template has an error in it, Docmosis will generate a blank data set.\n\n",
        "operationId" : "getSampleData",
        "requestBody" : {
          "content" : {
            "multipart/form-data" : {
              "schema" : {
                "$ref" : "#/components/schemas/GetSampleDataRequest"
              }
            },
            "application/json" : {
              "schema" : {
                "$ref" : "#/components/schemas/GetSampleDataRequest"
              }
            }
          }
        },
        "responses" : {
          "200" : {
            "description" : "Request succeeded",
            "headers" : {
              "X-Docmosis-Server" : {
                "$ref" : "#/components/headers/X-Docmosis-Server"
              }
            },
            "content" : {
              "application/json" : {
                "schema" : {
                  "$ref" : "#/components/schemas/GetSampleDataResponse"
                }
              }
            }
          },
          "400" : {
            "$ref" : "#/components/responses/400"
          },
          "404" : {
            "$ref" : "#/components/responses/404"
          },
          "415" : {
            "$ref" : "#/components/responses/415"
          },
          "500" : {
            "$ref" : "#/components/responses/500"
          }
        },
        "x-codeSamples" : [ {
          "lang" : "Shell",
          "label" : "Curl",
          "source" : "curl --request POST \\\n--url https://us1.dws4.docmosis.com/api/getSampleData \\\n--form 'templateName=/WelcomeTemplate.docx' \\\n--form 'accessKey='"
        }, {
          "lang" : "Java",
          "label" : "Java",
          "source" : "//This example uses the Apache HttpClient (v5) library\n\nHttpClient client = HttpClientBuilder.create().build();\nHttpPost request = new HttpPost(\"https://us1.dws4.docmosis.com/api/getSampleData\");\n\nString templateName = \"/WelcomeTemplate.docx\";\nString accessKey = \"\";\n\nMultipartEntityBuilder builder = MultipartEntityBuilder.create();\nbuilder.addTextBody(\"templateName\", templateName);\nbuilder.addTextBody(\"accessKey\", accessKey);\nHttpEntity payLoad = builder.build();\nrequest.setEntity(payLoad);\n\nclient.execute(request, response -> {\n    System.out.println(EntityUtils.toString(response.getEntity()));\n    EntityUtils.consume(response.getEntity());\n    return null;\n});"
        }, {
          "lang" : "C#",
          "label" : "C#",
          "source" : "HttpClient client = new HttpClient();\n\nstring templateName = \"/WelcomeTemplate.docx\";\nstring accessKey = \"\";\n\nMultipartFormDataContent content = new MultipartFormDataContent();\ncontent.Add(new StringContent(templateName), \"templateName\");\ncontent.Add(new StringContent(accessKey), \"accessKey\");\n\nusing (HttpResponseMessage response = await client.PostAsync(\"https://us1.dws4.docmosis.com/api/getSampleData\", content)) {\n    string responseString = await response.Content.ReadAsStringAsync();\n    Console.WriteLine(responseString);\n}"
        }, {
          "lang" : "Python",
          "label" : "Python",
          "source" : "import requests\n\ntemplateName = '/WelcomeTemplate.docx'\naccessKey = ''\n\npayload = {\n    'templateName' : templateName,\n    'accessKey' : accessKey\n}\n\nresponse = requests.post('https://us1.dws4.docmosis.com/api/getSampleData', stream=True, data=payload)\n\nprint(response.text)"
        }, {
          "lang" : "PHP",
          "label" : "Php",
          "source" : "<?php\n\n$templateName = \"/WelcomeTemplate.docx\";\n$accessKey = \"\";\n\n$request = array(\n    \"templateName\" => $templateName,\n    \"accessKey\" => $accessKey\n);\n\n$headers = array(\"Content-Type: multipart/form-data\");\n\n$curl = curl_init(\"https://us1.dws4.docmosis.com/api/getSampleData\");\n\ncurl_setopt($curl, CURLOPT_HEADER, 0);\ncurl_setopt($curl, CURLOPT_POST, 1);\ncurl_setopt($curl, CURLOPT_POSTFIELDS, $request);\ncurl_setopt($curl, CURLOPT_HTTPHEADER, $headers);\ncurl_setopt($curl, CURLOPT_FOLLOWLOCATION, 0);\ncurl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\n\necho $response;\n\n?>"
        }, {
          "lang" : "JavaScript",
          "label" : "Node.js",
[...]
